﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class PathFollower : MonoBehaviour {
    public List<Vector3> Offsets;
    public List<bool> reverseScaleX;
    public float Speed = 1;
    private Vector3 startPosition;
    public float pathLength;

    void OnDrawGizmosSelected()
    {
        Gizmos.color = Color.magenta;
        for (int i = 0; i < Offsets.Count; i++)
        {
            Gizmos.DrawLine(GetPosition(i), GetPosition(i + 1));
        }
        point = GetPointIndexFromDistance(t);
        var fromPosition = GetPosition((point.index));
        var toPosition = GetPosition((point.index) + 1);
        Gizmos.DrawSphere(Vector3.Lerp(fromPosition, toPosition, point.delta), 0.1f);
    }
    public bool debug = false;
	// Use this for initialization
	void Start () {
        startPosition = this.transform.position;
        pathLength = 0;
        for (int i = 0; i < Offsets.Count; i++)
        {
            pathLength += (GetPosition(i) - GetPosition(i + 1)).magnitude;
        }
	}
    public float t = 0;
    private linePoint GetPointIndexFromDistance(float d)
    { 
        float totalDistance = pathLength;
        d = d % pathLength;
        for (int i = Offsets.Count-1; i >= 0; i-- )
        {
            var mag = (GetPosition(i) - GetPosition(i + 1)).magnitude;
            totalDistance -= mag;
            if (totalDistance < d)
            {
                if (debug)
                    Debug.Log(d + "," +(d - totalDistance) + ", " + mag + "," + ((d - totalDistance) / mag));
                return new linePoint
                {
                    index = i,
                    delta = ((d - totalDistance) / mag)
                };
            }
        } 
        return new linePoint();
        
    }
    [System.Serializable]
    public struct linePoint
    {
        public int index;
        public float delta;
    }
    public Vector3 GetPosition(int n)
    {
        return (startPosition != Vector3.zero? startPosition: this.transform.position) + Offsets[n % Offsets.Count];
    }
    public linePoint point;
	// Update is called once per frame
	void Update () {
        t += Time.deltaTime * Speed;
        point = GetPointIndexFromDistance(t);
        var fromPosition = GetPosition((point.index));
        var toPosition = GetPosition((point.index) + 1);
        if (reverseScaleX != null && point.index < reverseScaleX.Count)
        {
            if (reverseScaleX[point.index])
            {
                this.transform.localScale = new Vector3(-1, 1, 1);
            }
            else
            {
                this.transform.localScale = new Vector3(1, 1, 1);
            }
        }
        this.transform.position = Vector3.Lerp(fromPosition, toPosition, point.delta);
        t = t % pathLength;
	}
}
