﻿using UnityEngine;
using System.Collections;

public class PlayerHealth : MonoBehaviour {
    public Simple2dPlatformController Player;
    public Vector3 CheckpointPosition;
    public AudioClip CrushSound,DeathSound,RespawnSound;
    public GameObject DeathPrefab,RespawnPrefab;
    private bool SetCheckpointOnGrounded = true;
    public void SetCheckpoint()
    {
        SetCheckpointOnGrounded = true;
    }
    private void doSetCheckpoint() {
        SetCheckpointOnGrounded = false;
        CheckpointPosition = this.transform.position;
    }
    public void Crushed()
    {
        if (isDying) return;
        if (CrushSound != null)
        {
            AudioSource.PlayClipAtPoint(CrushSound, this.transform.position);
        }
        Kill();
    }
    public void Kill()
    {
        if (isDying) return;
        if (DeathSound != null)
        {
            AudioSource.PlayClipAtPoint(DeathSound, this.transform.position);
        }
        if (DeathPrefab != null)
        {
            Instantiate(DeathPrefab, this.transform.position, Quaternion.identity);
        }
        StartCoroutine(doKill());
    }
    private bool isDying = false;
    private IEnumerator doKill()
    {
        isDying = true;
        Player.enabled = false;
        Player.GraphicsRoot.gameObject.SetActive(false);
        yield return new WaitForSeconds(2);
        this.transform.parent = null;
        this.transform.rotation = Quaternion.identity;
        this.transform.position = CheckpointPosition;
        Player.Velocity = Vector2.zero;
        if (RespawnSound != null) AudioSource.PlayClipAtPoint(RespawnSound, this.transform.position);
        if (RespawnPrefab != null) Instantiate(RespawnPrefab, this.transform.position, Quaternion.identity);
        yield return new WaitForSeconds(2);

        Player.enabled = true;
        Player.GraphicsRoot.gameObject.SetActive(true);

        isDying = false;
    }
	// Use this for initialization
	void Start () {
        doSetCheckpoint();
	}
	
	// Update is called once per frame
	void Update () {
        if (SetCheckpointOnGrounded && Player.isGrounded && Player.transform.parent != null && Player.transform.parent.tag != "DontCheckpoint")
        {
            doSetCheckpoint();
        }
	}
}
