﻿using UnityEngine;
using System.Collections;

public class PlayerMoveableWall : MonoBehaviour {
    public float Speed = 4f;
    public bool MoveHoriz, MoveVert;
    public Vector3 Bounds;
    private Vector3 StartPos;
    private Vector3 Offset;
    public bool FromCenter = true;
    void Awake()
    {
        StartPos = this.transform.position;
        Offset = new Vector3();
    }

	// Update is called once per frame
	void Update () {
        if (MoveHoriz)
        {
            var horizontal = RInput.GetAxis("Vertical");// RInput.GetAxis("Horizontal");
            if (horizontal != 0)
            {
                Offset.x += Time.deltaTime * Speed * horizontal;
            }
        }
        if (MoveVert)
        {
            var vertical = RInput.GetAxis("Vertical");
            if (vertical != 0)
            {
                Offset.y += Time.deltaTime * Speed * vertical;

            }
        }
        if (Bounds.x < 0)
        {
            Offset.x = Mathf.Clamp(Offset.x,
                Bounds.x ,
                0);
        }
        else
        {
            Offset.x = Mathf.Clamp(Offset.x,
                FromCenter ? -Bounds.x : 0,
                Bounds.x);
        }
        if (Bounds.y < 0)
        {
            Offset.y = Mathf.Clamp(Offset.y, Bounds.y, 0);
        }
        else
        {
            Offset.y = Mathf.Clamp(Offset.y, FromCenter ? -Bounds.y : 0, Bounds.y);
        }
        this.transform.position = StartPos + Offset;
	}
}
