﻿using UnityEngine;
using System.Collections;
using UnityEngine.Events;

public class UseToggle : MonoBehaviour {
    public bool IsOn = false;
    public BooleanEvent OnToggle;
    public BooleanEvent OnInverseToggle;
    public string AnimatorParameter = "On";
    public AudioClip OnSound, OffSound;
    private Animator _animator;
    private Animator animator
    {
        get
        {
            if (_animator == null) _animator = this.GetComponent<Animator>();
            return _animator;
        }
    }
    public void Start()
    {
        animator.SetBool(AnimatorParameter, IsOn); 
    }
    public void Use()
    {
        IsOn = !IsOn;
        if (OnToggle != null) OnToggle.Invoke(IsOn);
        if (OnInverseToggle != null) OnInverseToggle.Invoke(!IsOn);
        animator.SetBool(AnimatorParameter, IsOn);
        if (IsOn)
        {
            AudioSource.PlayClipAtPoint(OnSound, this.transform.position);
        }
        else
        {
            AudioSource.PlayClipAtPoint(OffSound, this.transform.position);
        }
    } 
}
